using UnityEngine;

namespace Mod
{
    public class BIM
    {
        public static void Main()
        {
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "War Machine", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Congrats cap. Now you are criminal.", //new item description
					CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb53.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
									
									
						
						
						
						
						
						
						
						
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("WarMachine/Mark3Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0f, 0f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("WarMachine/Mark3ARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

											
									
									
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("WarMachine/Mark3.png"), ModAPI.LoadTexture("WarMachine/Mark3.png"), null, 1);
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3Head.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3Head.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3Head.png"));
									
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3Upper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3Upper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3Upper.png"));
									
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3Middle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3Middle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3Middle.png"));
									
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3Lower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3Lower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3Lower.png"));
									
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark2UpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark2UpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark2UpperLeg.png"));
								
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark2LowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark2LowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark2LowerLeg.png"));
									
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark2Foot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark2Foot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark2Foot.png"));
						
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark2UpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark2UpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark2UpperLeg.png"));
								
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark2LowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark2LowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark2LowerLeg.png"));
								
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark2Foot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark2Foot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark2Foot.png"));
									
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3UpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3UpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3UpperArm.png"));
							
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3LowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3LowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3LowerArm.png"));
								
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3UpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3UpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3UpperArm.png"));
								
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WarMachine/Mark3LowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("WarMachine/Mark3LowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("WarMachine/Mark3LowerArm.png"));
									
									 
									upper.gameObject.AddComponent<warmachineuni>();
									
									
									
									
								
									 
									//
									var Gun = new GameObject("Gun");
									Gun = GameObject.Instantiate(ModAPI.FindSpawnable("Light Machine Gun").Prefab);
									Gun.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									//
									
									
									
									Gun.GetOrAddComponent<FirearmBehaviour>().Cartridge = ModAPI.FindCartridge("50 BMG"); 		
									Gun.GetOrAddComponent<FirearmBehaviour>().Cartridge.Recoil *= 0f;										
									
									SpriteRenderer rotorRenderer = Gun.GetComponent<SpriteRenderer>();
									rotorRenderer.sprite = ModAPI.LoadSprite("WarMachine/Gun.png", 2f);
									rotorRenderer.sortingLayerName = "Default";
									Gun.transform.SetParent(head.transform);
									Gun.transform.localScale = new Vector3(1f, 1f);


									HingeJoint2D hingeJoint = Gun.GetOrAddComponent<HingeJoint2D>();
									hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
									hingeJoint.anchor = new Vector3(0f, 0f);
									JointAngleLimits2D limits = hingeJoint.limits;

									limits.min = 0;
									limits.max = -90;

									hingeJoint.limits = limits;
									hingeJoint.useLimits = true;
									hingeJoint.enableCollision = false;

									Gun.transform.localPosition = new Vector3(-0.2f, -0.15f);
									Gun.gameObject.layer = 10;
									Gun.FixColliders();
									//
									
									//
									var Body = new GameObject("Body");
									Body = GameObject.Instantiate(ModAPI.FindSpawnable("Grenade Launcher").Prefab);
									Body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									Body.GetComponent<PhysicalBehaviour>().MakeWeightless();
									
									

									SpriteRenderer rotorRenderer1 = Body.GetComponent<SpriteRenderer>();
									rotorRenderer1.sprite = ModAPI.LoadSprite("Transparent.png", 2f);
									rotorRenderer1.sortingLayerName = "Foreground";
									Body.transform.SetParent(middle.transform);
									Body.transform.localScale = new Vector3(1f, 1f);


									HingeJoint2D hingeJoint1 = Body.GetOrAddComponent<HingeJoint2D>();
									hingeJoint1.connectedBody = middle.GetComponent<Rigidbody2D>();
									hingeJoint1.anchor = new Vector3(0f, 0f);
									JointAngleLimits2D limits1 = hingeJoint1.limits;

									limits.min = 0;
									limits.max = 0;

									hingeJoint1.limits = limits;
									hingeJoint1.useLimits = true;
									hingeJoint1.enableCollision = false;

									Body.transform.localPosition = new Vector3(-0.2f, -0.15f);
									Body.gameObject.layer = 10;
									Body.FixColliders();
									//
									
									
									
									//
									var Mask = new GameObject("Mask");
									Mask = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
									Mask.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									//
									
									
									SpriteRenderer rotorRenderer2 = Mask.GetComponent<SpriteRenderer>();
									rotorRenderer2.sprite = ModAPI.LoadSprite("WarMachine/MaskMove.png", 2f);
									rotorRenderer2.sortingLayerName = "Foreground";
									Mask.transform.SetParent(head.transform);
									Mask.transform.localScale = new Vector3(1f, 1f);


									HingeJoint2D hingeJoint2 = Mask.GetOrAddComponent<HingeJoint2D>();
									hingeJoint2.connectedBody = head.GetComponent<Rigidbody2D>();
									hingeJoint2.anchor = new Vector3(0f, 0f);
									JointAngleLimits2D limits2 = hingeJoint2.limits;

									limits.min = -0.1f;
									limits.max = -30f;

									hingeJoint2.limits = limits;
									hingeJoint2.useLimits = true;
									hingeJoint2.enableCollision = false;
									//
									var Gun1 = new GameObject("Gun1");
									Gun1 = GameObject.Instantiate(ModAPI.FindSpawnable("Rocket Launcher").Prefab);
									Gun1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									Gun1.GetComponent<PhysicalBehaviour>().MakeWeightless();
									//
									
									
									
									Gun1.GetOrAddComponent<FirearmBehaviour>().Cartridge = ModAPI.FindCartridge("50 BMG"); 		
									Gun1.GetOrAddComponent<FirearmBehaviour>().Cartridge.Recoil *= 0f;										
									
									SpriteRenderer rotorRenderer3 = Gun1.GetComponent<SpriteRenderer>();
									rotorRenderer3.sprite = ModAPI.LoadSprite("WarMachine/Gun1.png", 2f);
									rotorRenderer3.sortingLayerName = "Bubbles";
									Gun1.transform.SetParent(head.transform);
									Gun1.transform.localScale = new Vector3(1f, 1f);


									HingeJoint2D hingeJoint3 = Gun1.GetOrAddComponent<HingeJoint2D>();
									hingeJoint3.connectedBody = head.GetComponent<Rigidbody2D>();
									hingeJoint3.anchor = new Vector3(0f, 0f);
									JointAngleLimits2D limits3 = hingeJoint3.limits;

									limits.min = 0;
									limits.max = -90;

									hingeJoint3.limits = limits;
									hingeJoint3.useLimits = true;
									hingeJoint3.enableCollision = false;

									Gun1.transform.localPosition = new Vector3(-0.2f, -0.15f);
									Gun1.gameObject.layer = 10;
									Gun1.FixColliders();
									
									{
										var childObject = new GameObject("eye");
										childObject.transform.SetParent(Mask.transform);
										childObject.transform.localPosition = new Vector3(0f, 0f);
										childObject.transform.localScale = new Vector3(1f, 1f);
										var childSprite = childObject.AddComponent<SpriteRenderer>();
										childSprite.sprite = ModAPI.LoadSprite("MaskEye.png" ,2f);
										childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
										childObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

										childSprite.color = new Color(1f, 0f, 0f, 0.5f);
									}	

									Mask.transform.localPosition = new Vector3(-0.085f, 0.17f);
									Mask.gameObject.layer = 10;
									Mask.FixColliders();
									//
									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
									
										
									}
									
									arm1.gameObject.AddComponent<BarretBehaviour>();
									arm2.gameObject.AddComponent<BarretBehaviour>();
									GameObject alsoEye = new GameObject();
									alsoEye.transform.parent = arm1;
									alsoEye.transform.localPosition = new Vector3(0f, 0f);
									alsoEye.transform.localScale = new Vector3(1f, 1f);

									var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

									eyeSprite.sprite = ModAPI.LoadSprite("WarMachine/Mark3LowerArm.png");
									eyeSprite.material = ModAPI.FindMaterial("Sprites-Default");
									eyeSprite.sortingLayerName = "Bubbles";

									GameObject secondarm = new GameObject();
									secondarm.transform.parent = arm2;
									secondarm.transform.localPosition = new Vector3(0f, 0f);
									secondarm.transform.localScale = new Vector3(1f, 1f);

									var armSprite = secondarm.AddComponent<SpriteRenderer>();

									armSprite.sprite = ModAPI.LoadSprite("WarMachine/Mark3LowerArm.png");
									armSprite.material = ModAPI.FindMaterial("Sprites-Default");
									armSprite.sortingLayerName = "Bottom";
												
								var skin = ModAPI.LoadTexture("WarMachine/Mark2.png");
							var flesh = ModAPI.LoadTexture("WarMachine/Mark2.png");
						var bone = ModAPI.LoadTexture("WarMachine/Mark2.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
		}
	}
}